#include "epicardium.h"

#include <stdarg.h>
#include <stdio.h>

#include "py/mpprint.h"
#include "py/mphal.h"

#include <string.h>

int printf(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	int ret = mp_vprintf(MP_PYTHON_PRINTER, fmt, ap);
	va_end(ap);
	return ret;
}

int putc(int c, FILE *f)
{
	char chr = (char)c;
	epic_uart_write_str(&chr, 1);
	return c;
}

int putchar(int c)
{
	char chr = (char)c;
	epic_uart_write_str(&chr, 1);
	return c;
}

int puts(const char *s)
{
	int length = strlen(s);
	if (length) {
		epic_uart_write_str(s, length);
	}
	return length;
}

int snprintf(char *str, size_t size, const char *format, ...)
{
	/* TODO: What should we do with this? */
	return -EIO;
}

int fiprintf(FILE *f, const char *fmt, ...)
{
	/* TODO: What should we do with this? */
	return -EIO;
}
